<?php
namespace App\Report;

use App\Report\Format\PDF;
use App\Report\Format\XLS;
use App\Util\RequestHandler;

class ReportBuilder {
  public static function export($data) {
    $data['dateTime'] = $data['dateTime'] ?? (new \DateTime())->format('d/m/Y H:i:s');
    $data['logoImg'] = $data['logoImg'] ?? RequestHandler::getHost() . '/assets/retail-control.png';
    $customOptions = [];

    switch($data['format']) {
      case 'PDF':
        return (new PDF())->export($data, $customOptions);
      case 'XLS':
        return (new XLS())->export($data, $customOptions);
      default:
        throw new \Exception('Formato de exportação inválido.');
    }
  }
}