<?php

namespace App\Service;
use PHPMailer\PHPMailer\PHPMailer;

class SMTPService {

  private $operatorFactory;
  private $template;

  public function __construct (
                                \App\Factory\Operator $operatorFactory,
                                \App\Util\TemplateSMTP $template
                                ) {
    $this->operatorFactory  = $operatorFactory;
    $this->template         = $template;
  }

  public function sendEmail($name, $email, $subject, $content) {
      $SMTP = $this->operatorFactory->getSMTP();
      $auth = $SMTP[0]['IDTPAUTHSMTP'] === 'S' ? true : false;
      $generateEmail = $this->template->generateTemplateHTML($name, $subject, $content);

      $mail = new PHPMailer;
      $mail->isSMTP();
      $mail->CharSet    = 'UTF-8';
      $mail->Host       = $SMTP[0]['DSSMTPAUTVND'];
      $mail->SMTPAuth   = $auth;
      $mail->SMTPSecure = $SMTP[0]['DSSMTPCRIPT'];
      $mail->Port       = $SMTP[0]['NRPORTAAUTVND'];
      $mail->Username   = 'app@tecfood.com';
      $mail->Password   = $SMTP[0]['CDSENHAAUTVNDWEB'];

      $mail->setFrom($SMTP[0]['DSEMAILAUVND']);
      $mail->addAddress($email, $name);

      if($mail->SMTPSecure === 'tls') {
        $mail->SMTPOptions = [
          'ssl' => [
            'verify_peer'       => false,
            'verify_peer_name'  => false,
            'allow_self_signed' => true
          ]
        ];
      }

      $mail->isHTML(true);
      $mail->Subject = $subject;
      $mail->Body    = $generateEmail;

      if (!$mail->send()) {        
        return array(
          'message' => 'Houve um erro ao enviar o e-mail de verificação.',
          'error'   => true,       
        );      
      }
    }
  }